//this defines an input pattern
import java.awt.*;

class Inppat
{
   int patternType;
   int elementsInPattern;
   int pattern[][];
   int curPatternVariant = 10;
   int patternVariants = 10;
   int networkCols, networkRows;
   private int patternColSize,patternRowSize;

public static int patternModifier = 20;
private int MAXIMUMVARIANTS = 10;
   
public static int CYCLESPERRUN= 50;

private int monksInput[];

private int Size() {return networkCols*networkRows;}

public  int get_elements_in_pattern() 
   {return elementsInPattern;};

public Inppat(){}

//set up the external inputs that can occur.
public Inppat(int type,int netCols, int netRows)
{
   int size;
   networkCols = netCols;
   networkRows = netRows;
   size = Size();

   if (type == 1)
      {
      elementsInPattern = size;
	  patternVariants = 1;
      }
   else if ((type == 2) || (type ==5)) 
      {
      elementsInPattern = size/2;
	  patternVariants = 2;
      }
	  
   else if  (type == 4) 
      {
      elementsInPattern = size/4;
	  patternVariants = 1;
      }	  
	  
   else if (type == 3) 
      {
      elementsInPattern = (size/2) +  patternModifier;
	  patternVariants = 2;  
      }
   else if (type == 6) 
      {
      elementsInPattern = (size/2);
	  patternVariants = 1;
      }
   else if (type == 7) 
      {
      patternRowSize = networkCols/3;
	  patternColSize = networkRows/2;
      elementsInPattern = patternColSize*patternRowSize;
	  patternVariants = 6;
      }
   else if (type == 8) 
      {
      patternRowSize = networkCols/3;
      patternColSize = networkRows/2;
      elementsInPattern = patternColSize*patternRowSize*3;
	  patternVariants = 2;
      }
   else if (type == 9) 
      {
	  patternRowSize = networkCols/5;
	  patternColSize = networkRows/4;
	  elementsInPattern = patternColSize*patternRowSize*9; //6 feature values 3 output values
	  patternVariants = 1;  //There are so many variants we are going to
	                        //create them dynamically.
      }
   else if (type == 10) 
      {
	  elementsInPattern = networkCols*networkRows/5;
      patternVariants = 10; 
      }
   else if (type == 11) //cat, dog, rat
      {
      elementsInPattern = networkCols*networkRows/2;
      patternVariants = 3; 
      }	 
   else if (type == 12) 
      {
      elementsInPattern = (networkCols*networkRows/10)*3;
      patternVariants = 1; 
      }	 
   else if (type == 13) 
      {
      elementsInPattern = (networkCols*networkRows/10);
      patternVariants = 10; 
      }	
   else if (type == 14) 
      {
      elementsInPattern = (size/4);
      patternVariants = 4;  
      }
	  
   //This is the axonal variance version 3	  
   else if (type == 15) 
      {
	  if ((size/2) > (patternModifier*2))
         elementsInPattern = (size/2) -  patternModifier;
      else 
         elementsInPattern = patternModifier;
      patternVariants = 3;  
      }
  
	  
   pattern = new int[MAXIMUMVARIANTS][elementsInPattern];
   //System.out.print (elementsInPattern + " d\n");

   patternType = type;
   
   for (int variant = 0; variant < patternVariants; variant++)
      SetPattern(type,variant);
}

private void SetPattern(int type, int patternVersion)
{
   patternType = type;
   int numPatCols = 5;

   //the entire net.
   if (type == 1)
      {
      for (int offset=0; offset < elementsInPattern; offset++)
         pattern[patternVersion][offset] = offset;
      }
	  
   //the pattern is 0-199 (top half)
   else if ((type == 2) && (patternVersion == 0))
     {
     for (int offset=0; offset < elementsInPattern; offset++)
       pattern[patternVersion][offset] = offset;
     }  


   //the pattern is 200-399 (bottom half)
   else if ((type == 2) && (patternVersion == 1))
     {
     for (int offset=0; offset < elementsInPattern; offset++)
       pattern[patternVersion][offset] = elementsInPattern+ offset;
     }

   //0-199  + pattern_modifier
   else if ((type == 3) && (patternVersion == 0))
     {
     for (int offset=0; offset < elementsInPattern; offset++)
       pattern[patternVersion][offset] = offset;
     }
   //the pattern is 200-pattern_modifier - 399
   else if ((type == 3) && (patternVersion == 1))
     {
     for (int offset=0; offset < elementsInPattern; offset++)
       pattern[patternVersion][offset] = 
	      (elementsInPattern-(2*patternModifier)) + offset;
     }
   //all the even neurons
   else if (type == 4)
     {
     for (int offset=0; offset < elementsInPattern; offset++)
       pattern[patternVersion][offset] = offset;
     }
   //The first ten neurons
   else if (type == 5)
     {
     for (int offset=0; offset < elementsInPattern; offset++)
       pattern[patternVersion][offset] = offset%10;
     }
   else if (type == 6)
       {
	   elementsInPattern = 200;
	   patternVersion = 0;
       for (int offset=0; offset < elementsInPattern; offset++)
         pattern[patternVersion][offset] = offset%2;
       }
	 
   else if (type == 7)
      {
      int row=0,col=0,offset;
      for (offset=0; offset < elementsInPattern; offset++)
	     {
         if (patternVersion == 0)	 
		    {
			row=offset/patternRowSize;
            col=offset%patternRowSize;
		    }
	     else if (patternVersion == 1)
            {
	        row=offset/patternRowSize;
	        col=(offset%patternRowSize)+patternRowSize;
	        }
	     else if (patternVersion == 2)
	        {
	        row=offset/patternRowSize;
	        col=(offset%patternRowSize)+(2*patternRowSize);
	        }
	     else if (patternVersion == 3)
	        {
            row=(offset/patternRowSize)+patternColSize;
	        col=offset%patternRowSize;
	        }
	     else if (patternVersion == 4)
	        {
	        row=(offset/patternRowSize)+patternColSize;
	        col=(offset%patternRowSize)+patternRowSize;
	        }
	     else if (patternVersion == 5)
	        {
	        row=(offset/patternRowSize)+patternColSize;
	        col=(offset%patternRowSize)+(2*patternRowSize);
	        }
		 else System.out.print ("invalid pattern variant\n");
		 
	     pattern[patternVersion][offset] = 
		    (row*networkCols)+col;
	     }
      }	
   else if (type == 8)
	  {
	  int row=0,col=0,offset;
	  for (offset=0; offset < elementsInPattern/3; offset++)
	     {
	     if (patternVersion == 0)	 
	  	    {
	     	row=offset/patternRowSize;
	        col=offset%patternRowSize;
	     	}
	     else if (patternVersion == 1)
	        {
	        row=offset/patternRowSize;
	        col=(offset%patternRowSize)+patternRowSize;
	        }
		 else System.out.print ("Error in Pattern Generation\n");
	     pattern[patternVersion][offset] = 
	       (row*networkCols)+col;
         //System.out.print (pattern[patternVersion][offset] + "a\n");
	     }
      int offsetStart = elementsInPattern/3;		 
      for (offset = offsetStart; offset < 2*(elementsInPattern/3); offset++)
         {
         if (patternVersion == 0)	 
	        {
	        row=(offset-offsetStart)/patternRowSize;
	        col=((offset-offsetStart)%patternRowSize)+(2*patternRowSize);
	        }
	     else 
	        {
	        row=((offset-offsetStart)/patternRowSize)+patternColSize;
	        col=(offset-offsetStart)%patternRowSize;
	        }
         pattern[patternVersion][offset] = 
           (row*networkCols)+col;
         }
      offsetStart = 2*(elementsInPattern/3);		 
      for (offset=offsetStart; offset < elementsInPattern; offset++)
	     {
	     if (patternVersion == 0)	 
	       {
	       row=((offset-offsetStart)/patternRowSize)+patternColSize;
	       col=((offset-offsetStart)%patternRowSize)+patternRowSize;
	       }
	     else
	       {
	       row=((offset-offsetStart)/patternRowSize)+patternColSize;
	       col=((offset-offsetStart)%patternRowSize)+(2*patternRowSize);
	       }
	     pattern[patternVersion][offset] = 
	       (row*networkCols)+col;
	     }		   
      }

   else if (type == 9)
      {
      int feature1=1, feature2=1,feature3=1,feature4=1,feature5=1,feature6=1;
      System.out.print (patternVersion + "\n");
      //patternVersion is used to set the feature here, but shouldn't
      //be used for pattern reference (there's really only one version
      //for type 9.  So reset it.
      patternVersion = 0;
      
      boolean outputOn=false;
      if (feature5 == 1) outputOn=true;
      int row=0,col=0,offset;
      //feature 1
      for (offset=0; offset < elementsInPattern/9; offset++)
         {
        	row=offset/patternRowSize+(feature1*patternColSize);
         col=offset%patternRowSize;
         pattern[patternVersion][offset] =  (row*networkCols)+col;
         }		
      //feature2
      for (offset=0; offset < elementsInPattern/9; offset++)
         {
        	row=offset/patternRowSize+((feature2-1)*patternColSize);
         col=offset%patternRowSize+(patternRowSize);
         pattern[patternVersion][offset+elementsInPattern/9] =  (row*networkCols)+col;
         }		
      //feature 3
      for (offset=0; offset < elementsInPattern/9; offset++)
         {
      row=offset/patternRowSize+((feature3-1)*patternColSize);
         col=offset%patternRowSize+(2*patternRowSize);
         pattern[patternVersion][offset+2*(elementsInPattern/9)] =  (row*networkCols)+col;
         }		
      //feature 4
      int f4Row=0,f4Col=0;
      if (feature4 == 1) 
      {f4Row = 2;f4Col=2;}
      else if (feature4 == 2) 
      {f4Row = 3;f4Col=2;}
      else if (feature4 == 3) 
      {f4Row = 0;f4Col=3;}
      for (offset=0; offset < elementsInPattern/9; offset++)
         {
      row=offset/patternRowSize+(f4Row*patternColSize);
         col=offset%patternRowSize+(f4Col*patternRowSize);
         pattern[patternVersion][offset+3*(elementsInPattern/9)] =  (row*networkCols)+col;
         }		
      //feature 5
      int f5Row=0,f5Col=0;
      if (feature5 == 1) 
      {f5Row = 2;f5Col=3;}
      else if (feature5 == 2) 
      {f5Row = 3;f5Col=3;}
      else if (feature5 == 3) 
      {f5Row = 0;f5Col=4;}
      else if (feature5 == 4) 
      {f5Row = 1;f5Col=4;}
      for (offset=0; offset < elementsInPattern/9; offset++)
         {
      row=offset/patternRowSize+(f5Row*patternColSize);
         col=offset%patternRowSize+(f5Col*patternRowSize);
         pattern[patternVersion][offset+4*(elementsInPattern/9)] =  (row*networkCols)+col;
         }		
      //feature 6
      for (offset=0; offset < elementsInPattern/9; offset++)
         {
      row=offset/patternRowSize+((feature6+1)*patternColSize);
         col=offset%patternRowSize+(4*patternRowSize);
         pattern[patternVersion][offset+5*(elementsInPattern/9)] =  (row*networkCols)+col;
         }		
      //outputs
      if (outputOn) 
         {
         for (offset=0; offset < elementsInPattern/9; offset++)
            {
            row=offset/patternRowSize;
            col=offset%patternRowSize;
            pattern[patternVersion][offset+6*(elementsInPattern/9)] =  (row*networkCols)+col;
            }		
         for (offset=0; offset < elementsInPattern/9; offset++)
      	   {
            row=offset/patternRowSize+(3*patternColSize);
            col=offset%patternRowSize+(patternRowSize);
            pattern[patternVersion][offset+7*(elementsInPattern/9)] =  (row*networkCols)+col;
            }
         for (offset=0; offset < elementsInPattern/9; offset++)
         {
            row=offset/patternRowSize+(patternColSize);
            col=offset%patternRowSize+(3*patternRowSize);
            pattern[patternVersion][offset+8*(elementsInPattern/9)] =  (row*networkCols)+col;
         	}
         }		
   }	
   else if ((type == 10) && (patternVersion == 9))
     {
        for (int offset=0; offset < elementsInPattern/2; offset++) {
           pattern[patternVersion][offset] = offset*10;
           pattern[patternVersion][offset+(elementsInPattern/2)] = (offset*10) + 9;
        }
     }

   else if ((type == 10) && (patternVersion != 9))
     {
        for (int offset=0; offset < elementsInPattern/2; offset++) {
           pattern[patternVersion][offset] = (offset*10) + patternVersion;
           pattern[patternVersion][offset+(elementsInPattern/2)] = (offset*10) + patternVersion + 1;
        }
     }
   //patterns for dog, cat and rat in mammal hopfield hierarchy
   else if ((type == 11) && (patternVersion == 0))
      {
         for (int offset=0; offset < elementsInPattern; offset++) {
            pattern[patternVersion][offset] = ((offset/numPatCols)*10);
			offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+3;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+4;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+5;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+8;
           }
      }	 
   else if ((type == 11) && (patternVersion == 1))
      {
         for (int offset=0; offset < elementsInPattern; offset++) {
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+1;
     		offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+3;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+4;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+6;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+9;
           }
      }
   else if ((type == 11) && (patternVersion == 2))
      {
         for (int offset=0; offset < elementsInPattern; offset++) {
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+2;
   		offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+3;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+4;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+7;
            offset++;
            pattern[patternVersion][offset] = ((offset/numPatCols)*10)+8;
           }
      }

   //pattern for mammal in mammal hopfield hierarchy
   else if (type == 12)
      {
         for (int offset=0; offset < elementsInPattern; offset++) {
            pattern[patternVersion][offset] = ((offset/3)*10)+3;
   		    offset++;
            pattern[patternVersion][offset] = ((offset/3)*10)+4;
            offset++;
            pattern[patternVersion][offset] = ((offset/3)*10)+8;
           }
      }
   else if (type == 13)
      {
         for (int offset=0; offset < elementsInPattern; offset++) {
            pattern[patternVersion][offset] = 
			   ((offset/3)*10)+patternVersion;
           }
      }
   else if (type == 14)
      {
         for (int offset=0; offset < elementsInPattern; offset++)
           pattern[patternVersion][offset] = 
		      offset + (patternVersion * elementsInPattern);
      }   
   else if ((type == 15)  && (patternVersion == 0))
      {
         for (int offset=0; offset < (Size()/2)-patternModifier; offset++)
           pattern[patternVersion][offset] = offset;
      }   
//crhz	  
   else if ((type == 15)  && (patternVersion == 1))
      {
         for (int offset=0; offset < (Size()/2)-patternModifier; offset++)
           pattern[patternVersion][offset] = offset + (Size()/2) + patternModifier;
      }   
   else if ((type == 15)  && (patternVersion == 2))
      {
         for (int offset=0; offset < patternModifier*2; offset++)
           pattern[patternVersion][offset] = offset + (Size()/2)-patternModifier;
         for (int offset=0; offset < elementsInPattern - (patternModifier*2); offset++)
           pattern[patternVersion][offset+(patternModifier*2)] = -1;	   
      }   
   else System.err.println("Error: incorrect pattern type\n");
}

void PrintPattern() {
	for (int curVersion = 0; curVersion<patternVariants; curVersion++)
	{
        System.out.print ("Version "+ curVersion + "\n");
		for (int curElement = 0; curElement<elementsInPattern; curElement++)
			System.out.print (curElement + " " +
			                  pattern[curVersion][curElement] + "\n");
	}

}

//Swap the randomized ones into the first Number_To_Activate Slots
public void Arrange(int numberToActivate) {
   int randPatternEl;
   int swap;
   int patternVersion = curPatternVariant;
   for (int i= 0; i < numberToActivate; i++) {
      randPatternEl = (int)(Math.random() * elementsInPattern);
      swap = pattern[patternVersion][i];
      pattern[patternVersion][i] = pattern[patternVersion][randPatternEl];
      pattern[patternVersion][randPatternEl] = swap;
      //System.out.print (pattern[patternVersion][i] + "\n");
   }
}


public void SetInputPattern(int CANTStep) {
   //change pattern9 after each set of cycles
   if (patternType == 9)
      {
      if ((CANTStep % CYCLESPERRUN) == 0)      {
         CANT20.net.Clear();
         SetPattern(9,CANTStep/CYCLESPERRUN);
         }
      }

   //for change each time change the pattern each cycle
   if (CANT20.net.ChangeEachTime)      {
      CANT20.net.Clear();	  
	  curPatternVariant++;
	  curPatternVariant %= patternVariants;
	  Arrange(CANT20.net.NeuronsToStimulate);
   }

   else if ((CANTStep % CYCLESPERRUN) == 0)      {
      CANT20.net.Clear();
// 	  if (patternType == 14) curPatternVariant = 1;
//      else {
	     curPatternVariant++;
         curPatternVariant %= patternVariants;
//      }
      Arrange(CANT20.net.NeuronsToStimulate);
   }
//   System.out.print (curPatternVariant + " c\n");
}

public void PrintSharedWeightsMonks(int fromVariant, int toVariant) {

   double positiveTotal = 0.0;
   double negativeTotal = 0.0;
   double positiveAverage,negativeAverage;
   int positiveAxons = 0;
   int negativeAxons = 0;
   int fromNeuronID,toNeuronID;
   Neuron fromNeuron; 
   String outputString;
   
   int row, col,toPatternNeuronID;
   int patternSize = (networkCols/5) * (networkRows/4);
   int fromRow = fromVariant%4; int fromCol = fromVariant/4;
   int toRow = toVariant%4; int toCol = toVariant/4;
   
   //Loop through each neuron in the fromVariant
   for (int fromElement = 0; fromElement < patternSize; fromElement++)
      {
	  row=fromElement/patternRowSize+(fromRow*patternColSize);
      col=fromElement%patternRowSize+(fromCol*patternRowSize);
      fromNeuronID = (row*networkCols)+col;

	  fromNeuron = CANT20.net.Neurons[fromNeuronID];
      //loop through each axon
	  for (int axonOffset=0; axonOffset < fromNeuron.CurrentAxons; axonOffset++)
	     {
		 toNeuronID = fromNeuron.Axons[axonOffset].ToNeuron.ID;
		 
		 //for (int toElement = 0; toElement < 2; toElement++)
         for (int toElement = 0; toElement < patternSize; toElement++)
		    {
			row=toElement/patternRowSize+(toRow*patternColSize);
			col=toElement%patternRowSize+(toCol*patternRowSize);
			toPatternNeuronID = (row*networkCols)+col;
			//if the currentaxon goes to a toVariant neuron
			if (toNeuronID == toPatternNeuronID) 
			   {
			   //for positive neurons
			   if (!fromNeuron.IsInhibitory)
			      {
                  positiveTotal += fromNeuron.Axons[axonOffset].Weight;
			      positiveAxons++;
			      }
			   else
			      {
                  negativeTotal += fromNeuron.Axons[axonOffset].Weight;
			      negativeAxons++;
			      }
			   //get out because you've already found the toNeuron	  
			   break; 	
			   }
		    }
	     }
      }
   positiveAverage = positiveTotal/positiveAxons;
   negativeAverage = negativeTotal/negativeAxons;

   //print to debug screen
   System.out.print("Totals from " + fromVariant + " to "+ toVariant + ": ");
   System.out.print(positiveTotal +" " + positiveAxons + " " + positiveAverage + " \n");
   System.out.print("inhibitory " + negativeTotal + " " + negativeAxons + " " + negativeAverage + " \n");
 
}							  

public void PrintSharedWeights() {
//   CANT20.cantFrame.OutputLabel.setText("Wt:A->A");
   for (int toPattern=0;toPattern<patternVariants;toPattern++)    {
      for (int fromPattern=0;fromPattern<patternVariants;fromPattern++)    {
         PrintSharedWeights(fromPattern,toPattern);
      }
   }
}

public void PrintSharedWeights(int fromVariant, 
                               int toVariant) {

   double positiveTotal = 0.0;
   double negativeTotal = 0.0;
   double positiveVariance = 0.0;
   double negativeVariance = 0.0;
   double positiveAverage,negativeAverage;
   int positiveAxons = 0;
   int negativeAxons = 0;
   int fromNeuronID,toNeuronID;
   Neuron fromNeuron; 
   String outputString;
   
   if (patternType == 9)
      {
	  	PrintSharedWeightsMonks(fromVariant, toVariant);
		return;
      }	

   //Loop through each neuron in the fromVariant
   for (int fromOffset = 0; fromOffset < elementsInPattern; fromOffset ++)
      {
	  fromNeuronID = pattern[fromVariant][fromOffset];
	  if (fromNeuronID >= 0)
	  {
	  fromNeuron = CANT20.net.Neurons[fromNeuronID];
      //loop through each axon
	  for (int axonOffset=0; axonOffset < fromNeuron.CurrentAxons; axonOffset++)
	     {
		 toNeuronID = fromNeuron.Axons[axonOffset].ToNeuron.ID;
		 
		 if (toNeuronID >= 0)
		 for (int toOffset = 0; toOffset < elementsInPattern; toOffset ++)
		    {
			//if the currentaxon goes to a toVariant neuron
			if (toNeuronID == pattern[toVariant][toOffset]) 
			   {
			   //for positive neurons
			   if (!fromNeuron.IsInhibitory)
			      {
                  positiveTotal += fromNeuron.Axons[axonOffset].Weight;
			      positiveAxons++;
//System.out.print(fromNeuronID + " " + toNeuronID + " " +
//fromNeuron.Axons[axonOffset].Weight + "\n");			      
                  }
			   else
			      {
                  negativeTotal += fromNeuron.Axons[axonOffset].Weight;
			      negativeAxons++;
			      }
			   //get out because you've already found the toNeuron	  
			   break; 	
			   }
		    }
	     }
	     }
      }
   positiveAverage = positiveTotal/positiveAxons;
   negativeAverage = negativeTotal/negativeAxons;

   //print to debug screen
   System.out.print("Totals from " + fromVariant + " to "+ toVariant + ": ");
   System.out.print(positiveTotal +" " + positiveAxons + " " + positiveAverage + " \n");
   System.out.print("inhibitory " + negativeTotal + " " + negativeAxons + " " + negativeAverage + "\n");
   
   //Loop through each neuron to get variance
   for (int fromOffset = 0; fromOffset < elementsInPattern; fromOffset ++)
      {
	  fromNeuronID = pattern[fromVariant][fromOffset];
	  if (fromNeuronID >= 0)
	  {
	  fromNeuron = CANT20.net.Neurons[fromNeuronID];
      //loop through each axon
	  for (int axonOffset=0; axonOffset < fromNeuron.CurrentAxons; axonOffset++)
	     {
		 toNeuronID = fromNeuron.Axons[axonOffset].ToNeuron.ID;
		 
		 if (toNeuronID >=0)
		 for (int toOffset = 0; toOffset < elementsInPattern; toOffset ++)
		    {
			//if the currentaxon goes to a toVariant neuron
			if (toNeuronID == pattern[toVariant][toOffset]) 
			   {
			   //for positive neurons
			   if (!fromNeuron.IsInhibitory)
			      {
                  positiveVariance += Math.abs(fromNeuron.Axons[axonOffset].Weight -
				     positiveAverage);
			      }
			   else
			      {
                  negativeVariance += Math.abs(fromNeuron.Axons[axonOffset].Weight -
                     negativeAverage);
			      }
			   //get out because you've already found the toNeuron	  
			   break; 	
			   }
		    }
	     }			
	     }
      }

   System.out.print("variance " + positiveVariance/positiveAxons + " " +
                    negativeVariance/negativeAxons+ "\n");

   System.out.print("\n");


   //modify the frame
   outputString = ("Totals from " + fromVariant + 
      " to "+ toVariant + ": " +
	  Double.toString(positiveAverage) 
	  );

   if (! CANT20.ApplicationNotApplet)
      CANT20.cantFrame.WriteToOutputWindow(outputString + "\n");
   
}							  

};

