//This can either run as an applet in which case init is used
//or as an application, in which case main is used.  The environment
//it runs from chooses (java debugger application web browser=applet)
//In Kawa 16/10/02
import java.io.*;
import java.util.*;
import java.applet.*;
import java.net.*;  //for URL

public class CANT20 extends Applet implements Runnable{

static Thread thread;
static Net net;
public static CantFrame cantFrame;
static Inppat inputPattern;
static boolean CREATE_INITIAL_NET = true;
static boolean isRunning=false;
static boolean READPARAMETERS = true;
static boolean READNET = false;
static boolean ApplicationNotApplet = false;
static int generateNetType = 5;

public static int Cols = 20;	
public static int Rows = 20;
   
public static String ParameterFileName="ParametersExp10.dat";
public static URL ParameterURL;



public static void main(String args[]){
   System.out.print ( "main\n");
   ApplicationNotApplet = true;

   if (CREATE_INITIAL_NET)    {
      //generate a new net 
      net = new Net(Cols,Rows);

      if (generateNetType <= 0) 
         net.SetConnections(0,Cols*Rows);
      else 	  {
         net.SetConnections(0,Cols*Rows,generateNetType);  }	 
   }
   else 
   {
      //create and read the net
      net = new Net();
      //net.CreateNet_dat();  //anita's persisting net
      net.Read();
	  Cols = net.Cols;
	  Rows = net.Rows;
   }
    
	
   CantFrame cantFrame = new CantFrame();
   
   inputPattern = new Inppat(11,Cols,Rows);

   while (true)
      if (isRunning) {

           cantFrame.RunOneCycle(inputPattern);
   }
}


public static void ChangePattern(int Type)
{
   if (Type < 16) {
      inputPattern = new Inppat(Type,net.Cols,net.Rows);
   }
   else System.err.println("Error: incorrect pattern type to net\n");
}



public URL MakeURL(String FileName)
    {
      URL lResult = null;
      try
      {
      // THIS IS THE KEY FUNCTION CALL TO ACCESS THE SERVER 
         lResult = new URL( this.getCodeBase(), FileName );
      }//try
      catch( MalformedURLException mal )
      {
        System.out.println( "Can't make URL" );
      }//catch MalformedURLException

      return lResult;
    }//MakeURL


public void init() {
   String Params;
   int InputPatternNum;
   
   System.out.print ( "init\n");   
   ApplicationNotApplet = false;
   resize(100,100);	  
   
   //Get parameters from the applet invocation
   Params = getParameter("inputfile");
   System.out.print ( Params + "\n");   
   if (Params != null)
   {
      ParameterFileName = Params;   
	  READPARAMETERS = true;
   }
   ParameterURL = MakeURL(ParameterFileName);

   Params = getParameter("rows");
   if (Params != null)
   	  Rows = Integer.parseInt(Params);
   Cols = Rows;	    

   Params = getParameter("pattern");
   if (Params != null)
   	  InputPatternNum = Integer.parseInt(Params);
   else  
      InputPatternNum = 1;

   Params = getParameter("generate");
   if (Params != null) 
   {
   	  generateNetType = Integer.parseInt(Params);
   }
   else  
      generateNetType = -1;

   if (CREATE_INITIAL_NET)    {
      //generate a new net 
      net = new Net(Cols, Rows);
	  
      if (generateNetType <= 0) 
         net.SetConnections(0,Cols*Rows);
      else 	  {
         net.SetConnections(0,Cols*Rows,generateNetType);  }	 
   }
   else 
   {
      //create and read the net
      net = new Net();
      net.Read();
   }

   inputPattern = new Inppat(InputPatternNum,Cols,Rows);
   
   cantFrame = new CantFrame();
   cantFrame.addWindowListener( new CloseExit());
   thread = new Thread(this);
   thread.start();

}
	  
public void run() {
   URL NetURL;
   
   while (true) 
   {
      if (READPARAMETERS) 	  {
	  	ParameterURL = MakeURL(ParameterFileName);
	  	net.ServerReadParameters(ParameterURL);
		READPARAMETERS = false;
      }

      if (READNET) 	  {
      	NetURL = MakeURL(net.NetFileName);
      	net.ServerReadNet(NetURL);
        READNET = false;
      }
	  
   	  //might have troubles if frame is still being created
      if (isRunning) {
         cantFrame.RunOneCycle(inputPattern);
         repaint();
      }
   }
}
}