//
// Matrix.java
//  integer array to form Matrix for the neurons to be placed

import java.awt.*;

public class Matrix {
   	public int[][] cells;
	private int _OX, _OY;
    private int i,j;
    private int downA, downB, acrossA, acrossB;
	private int MaxX, MaxY,MaxDimension;
	public static int MatrixSize=480;

//public int    _MAXY=Net.Rows;
//public int   _MAXX=Net.Cols;


Matrix (int Cols, int Rows, int __ox, int __oy) {
   int xcnt=0, ycnt=0;
   MaxX = Cols;
   MaxY = Rows;
   if (MaxX > MaxY) MaxDimension = MaxX;
   else MaxDimension = MaxY;

   cells=new int [Cols][Rows];

   _OX=__ox;
   _OY=__oy;

   for (ycnt=0; ycnt<Rows; ycnt++) {
	for (xcnt=0; xcnt< Cols; xcnt++) {
	   cells[xcnt][ycnt]=0;
}}}


public int setState(int x, int y, int state) {
   if (x< MaxX && y< MaxY && x>-1 && y>-1) {
     // System.out.print("_x=" + Integer.toString(_x));
      cells[x][y]=state;
      return state;
   }
   return 0;
}


public void paint(Graphics __g) {
   int xcnt, ycnt;
   int SquareSize=MatrixSize/MaxDimension;
 
   __g.setColor(Color.green);
   __g.fillRect(_OX, _OY, MaxX*SquareSize, MaxY*SquareSize);
   __g.setColor(Color.black);
   __g.drawRect(_OX, _OY, MaxX*SquareSize, MaxY*SquareSize);

   //set the color for drawing circles
   __g.setColor(new Color(190,0,190));

   //draw circles if the cell is on.

   for (ycnt=0; ycnt<MaxY; ycnt++) {
      for (xcnt=0; xcnt<MaxX; xcnt++) {
         if (cells[xcnt][ycnt]!=0) {
            __g.fillOval(_OX+(xcnt*SquareSize),
			   _OY+(ycnt*SquareSize),
               SquareSize,SquareSize);
      	 }
      }
   }

   //this creates the grid
   acrossA=_OX; //leftborder
   acrossB=acrossA + (MaxX*SquareSize);  //matches LeftBorder of Bacllayout

   downA=_OY;   //matches top border lentgh
   downB=downA + (MaxY*SquareSize);

   __g.setColor(new Color(23, 100, 180));

   //draw horizontal lines
   for(j=downA; j<downB; j+=SquareSize){
      if (j == (downA+(SquareSize*(MaxY/2))))
      __g.setColor(new Color(210,23,45));

      __g.drawLine(acrossA,j,acrossB,j);

      if (j == (downA+(SquareSize*(MaxY/2))))
         __g.setColor(new Color(23, 100, 180));
   }

   //draw vertical lines
   for(i=acrossA; i<acrossB; i+=SquareSize){
       __g.drawLine(i,downA,i,downB);
   }
}

	public int maxX() { return MaxX; }
	public int maxY() { return MaxY; }
}